# Defining previous compatible perl5.x libraries
%define perlmodcompat 5.8.6 5.8.5 5.8.4 5.8.3

Summary: The Perl programming language.
Name: perl
Version: 5.8.7
Release: 4tr
License: GPL
Group: Trustix Official
Url: http://www.perl.com
Source0: ftp://ftp.perl.org/pub/CPAN/src/perl-%{version}.tar.bz2
Source1: perl-headers-wanted
Source2: perl-5.8.0-h2ph-ansi_header.patch
Source3: perl-5.8.6-modexclude.sh
Patch1: perl-5.8.0-makemaker-ld_run_path.patch
Patch3: perl-5.8.2-root.patch
Patch4: perl-5.8.3-desthtml.patch
Patch5: perl-5.8.1-lpthread-link.patch
#Patch6: perl-5.8.5-tempfile.patch
Patch7: perl-5.8.7-CAN-2005-3962.patch
# 64 bit arch specific patches
Patch101: perl-5.8.0-libdir64.patch
Buildroot: %{_tmppath}/%{name}-root
Requires: gdbm
Requires: db4
BuildRequires: gdbm-devel
BuildRequires: db4-devel
Provides: perl
Provides: perl <= %{version}
Obsoletes: perl-devel, perl-doc
Provides: perl-devel, perl-doc


# Auto-generated perl.req which need to be excluded
%define __perl_requires %{SOURCE3}

# Compatible version of perl Provides
Provides: perl(:MODULE_COMPAT_5.8.3)
Provides: perl(:MODULE_COMPAT_5.8.4)
Provides: perl(:MODULE_COMPAT_5.8.5)
Provides: perl(:MODULE_COMPAT_5.8.6)

# These provides are needed by the perl pkg itself with auto-generated perl.req
Provides: perl(VMS::Filespec)
Provides: perl(VMS::Stdio)
Provides: perl(Carp::Heavy)
Provides: perl(FCGI)
Provides: perl(getopts.pl)
Provides: perl(bigint.pl)
Provides: perl(shellwords.pl)
Provides: perl(Pg)

%define multilib_64_archs x86_64 s390x ppc64 sparc64

%define full_arch %{_arch}-%{_os}-thread-multi
%define perl_root %{_prefix}/lib/perl5
%define perl_arch_root %{_libdir}/perl5



%description
Perl is a high-level programming language with roots in C, sed, awk
and shell scripting.  Perl is good at handling processes and files,
and is especially good at handling text.  Perl's hallmarks are
practicality and efficiency.  While it is used to do a lot of
different things, Perl's most common applications (and what it excels
at) are probably system administration utilities and web programming.
A large proportion of the CGI scripts on the web are written in Perl.
You need the perl package installed on your system so that your
system can handle Perl scripts.


%prep
%setup -q -n perl-%{version}
%patch1 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
#%patch6 -p1
%patch7 -p1

%ifarch %{multilib_64_archs}
%patch101 -p1
%endif

find . -name \*.orig -exec rm -fv {} \;


%build
rm -f config.sh Policy.sh
export LDFLAGS="-lpthread -s"

sh Configure -des \
    -Darchname=%{_arch}-%{_os} \
    -Dcc='%{__cc}' \
    -Dcf_by=Trustix \
    -Dd_semctl_semun \
    -Di_db \
    -Di_gdbm \
    -Dmyhostname=localhost \
    -Dcppflags="$RPM_OPT_FLAGS" \
%ifarch x86_64
    -Doptimize="$RPM_OPT_FLAGS -fPIC" \
%else
    -Doptimize="$RPM_OPT_FLAGS -DPERL_USE_SAFE_PUTENV" \
%endif
    -Dperladmin=root@localhost \
    -Dprefix=%{_prefix} \
    -Dsiteprefix=%{_prefix} \
    -Duselargefiles \
    -Dvendorprefix=%{_prefix} \
    -Dman3dir=%{_mandir}/man3 \
    -Dman1dir=%{_mandir}/man1 \
%ifarch %{multilib_64_archs}
    -Dlibpth="/usr/local/lib64 /lib64 /usr/lib64" \
%endif
    -Dprivlib="/usr/lib/perl5/%{version}" \
    -Dsitelib="/usr/lib/perl5/site_perl/%{version}" \
    -Dvendorlib="/usr/lib/perl5/vendor_perl/%{version}" \
    -Darchlib="%{_libdir}/perl5/%{version}/%{_arch}-%{_os}-thread-multi" \
    -Dsitearch="%{_libdir}/perl5/site_perl/%{version}/%{_arch}-%{_os}-thread-multi" \
    -Dvendorarch="%{_libdir}/perl5/vendor_perl/%{version}/%{_arch}-%{_os}-thread-multi" \
    -Dusethreads \
    -Duseithreads \
    -Dd_semctl_semun \
    -Dinc_version_list='%{perlmodcompat}'

make

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT

make DESTDIR=$RPM_BUILD_ROOT install extras.install

pushd $RPM_BUILD_ROOT/%{_libdir}/perl5
for i in %{perlmodcompat}; do
    mkdir -pm 755 $i/%{_arch}-%{_os}-thread-multi/CORE
    mkdir -pm 755 $i/%{_arch}-%{_os}-thread-multi/auto
    pushd $i/%{_arch}-%{_os}-thread-multi/CORE
      ln -s ../../../%{perlver}/%{_arch}-%{_os}-thread-multi/CORE/libperl.a libperl.a
    popd
  done
popd

install -m 755 utils/pl2pm ${RPM_BUILD_ROOT}%{_prefix}/bin/pl2pm

cp -f utils/h2ph utils/h2ph_patched
bzcat %{SOURCE2} | patch -p1

install -d -m 755 $RPM_BUILD_ROOT%{perl_root}/%{version}/%{full_arch}/auto
install -d -m 755 $RPM_BUILD_ROOT%{perl_root}/site_perl/%{version}/%{_arch}-linux
%ifarch %{multilib_64_archs}
install -d -m 755 $RPM_BUILD_ROOT%{perl_arch_root}/%{version}/%{full_arch}/auto
install -d -m 755 $RPM_BUILD_ROOT%{perl_arch_root}/site_perl/%{version}/%{_arch}-linux
%endif

# This fails on sys/_types.h.  Ignore for now.
LD_LIBRARY_PATH=. ./perl -Ilib utils/h2ph_patched -a -d $RPM_BUILD_ROOT%{perl_root}/%{version}/%{full_arch} `cat %{SOURCE1}` > /dev/null || :

(
    # i don't like hardlinks, having symlinks instead:
    cd $RPM_BUILD_ROOT%{_bindir}
    ln -sf perl5 perl
    ln -s perl%{version} perl5
)



(cd $RPM_BUILD_ROOT%{_mandir}/man3/
	mv threads.3 perlthreads.3)

# stip binaries:
strip $RPM_BUILD_ROOT%{_bindir}/a2p
strip $RPM_BUILD_ROOT%{_bindir}/perl%{version}

#let this directory be a part of perl henceforth
mkdir -p -m755 $RPM_BUILD_ROOT%{perl_sitearch}/auto/

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT


%files 
%defattr(-,root,root,0755)
%doc README
%{_bindir}/*
%{perl_root}
%ifarch %{multilib_64_archs}
%{_libdir}/perl5
%endif
%dir %{perl_sitearch}/auto
%{_mandir}/*/*

%changelog
* Mon Feb 26 2007 Nived Gopalan <nived at trustix dot org>
- Rebuilt

* Mon Dec 19 2005 Ajith Thampi <ajith at trustix dot org> 5.8.7-3tr
- Added 5.8.6 comapatibility
- Fixed compat perl libs naming
 		
* Mon Dec 05 2005 Bipin S <bipin at trustix dot org> 5.8.7-2tr
- Integer overflow in the format string functionality (Perl_sv_vcatpvfn) 
  allows attackers to overwrite arbitrary memory and possibly execute 
  arbitrary code via format string specifiers with large values.

  The Common Vulnerabilities and Exposures project has assigned the
  name CVE-2005-3962 to this issue.

* Mon Jun 06 2005 Ajith Thampi <ajith at comodo dot com> 5.8.7-1tr
- New Upstream
- Added -Dinc_version_list for compatibility with older perl5.x
		
* Wed May 04 2005 Ajith Thampi <ajith at comodo dot com> 5.8.6-7tr
- Rebuilt to fix segfaulting with apache, added -DPERL_USE_SAFE_PUTENV
  and -Duseithreads -Dd_semctl_semun to get it working. 
 
* Tue Apr 26 2005 Ajith Thampi <ajith at comodo dot com> 5.8.6-6tr
- Rebuilt on db-4.3.27

* Fri Apr 01 2005 Ajith Thampi <ajith at comodo dot com> 5.8.6-5tr
- Added a few Provides which are auto-generated by perl.req
- Removed some auto-generated requires

* Thu Mar 31 2005 Ajith Thampi <ajith at comodo dot com> 5.8.6-4tr
- Rebuilt with perl.req fix

* Tue Mar 22 2005 Ajith Thampi <ajith at comodo dot com> 5.8.6-3tr
- Added /auto directory as part of perl, Bug #77
 
* Mon Mar 21 2005 Ajith Thampi <ajith at comodo dot com> 5.8.6-2tr
- Rebuilt to fix pthread support
- Fixed perl module dependencies

* Mon Mar 07 2005 Ajith Thampi <ajith at comodo dot com> 5.8.6-1tr
- New Upstream

* Wed Feb 02 2005 Ajith Thampi <ajith at comodo dot com> 5.8.5-4tr
- Rebuild for db-4.2.52

* Tue Nov  9 2004 Erlend Midttun <erlendbm at trustix dot org> 5.8.5-3tr
- Now also create (and own) %{perl_root}/%{version}/%{full_arch}/auto

* Thu Nov  4 2004 Oystein Viggen <oysteivi at trustix dot com> 5.8.5-2tr
- Tempfile patch

* Mon Sep 27 2004 Erlend Midttun <erlendbm at trustix dot org> 5.8.5-1tr
- New upstream.

* Mon Aug  9 2004 Erlend Midttun <erlendbm at trustix dot org> 5.8.4-2tr
- Use _lib macro

* Wed Jul  7 2004 Chr. Toldnes <christht at trustix dot org> 5.8.4-1tr
- New upstream version: 5.8.4
- Merge sub-packages.
- clean up
- remove suid perl

* Wed May 12 2004 Oystein Viggen <oysteivi at trustix dot com> 5.8.3-5tr
- Use -fPIC for libraries

* Tue Apr 13 2004 Oystein Viggen <oysteivi at trustix dot com> 5.8.3-4tr
- Don't hardcode lib directory name for binary modules

* Thu Jan 22 2004 Erlend Midttun <erlendbm at trustix dot org> 5.8.3-1tr
- New upstream.

* Wed Dec 17 2003 Gerald Dachs <gda at trustix dot org> 5.8.0-16tr
- rebuild against libgdbm.so.3
- patched again to work with db4-4.1.25 (patch5)
- ndbm support was in %files section but not in config
- fixed typo: perltreads => perlthreads

* Wed Nov 26 2003 Erlend Midttun <erlendbm at trustix dot com> 5.8.0-15tr
- Big rebuild.

* Fri Oct 31 2003 Chr. Toldnes <christht at trustix dot org> 5.8.0-14tr
- backport

* Sun Sep 28 2003 Chr. Toldnes <christht at tawie dot org> 5.8.0-13tsl
- port to tawie

* Thu Jul 31 2003 Goetz Bock <bock at trustix dot org> 5.8.0-12bg
- fixed CGI.pm XSS bug (patch4)
- added patch for install suid root perl /wo beeing root (patch3)

* Tue Jul 29 2003 Goetz Bock <bock at trustix dot org> 5.8.0-11bg
- added patches (patch0, patch1) to make MakeMaker work sane again
- fixed Groups for -doc and -devel

* Mon Jun 23 2003 Erlend Midttun <erlendbm at trustix dot com> 5.8.0-10tr
- Added %defattr.

* Thu Jun 19 2003 Erlend Midttun <erlendbm at trustix dot com> 5.8.0-9tr
- Fixed group.

* Wed Jun 18 2003 Erlend Midttun <erlendbm at trustix dot com> 5.8.0-8tr
- Big rebuild.

* Sat Jun  7 2003 Gerald Dachs <gda at trustix dot org> 5.8.0-7gd
- fixed default man dir in MakeMaker

* Sat Jun  7 2003 Erlend Midttun <erlendbm at trustix dot com> 5.8.0-6em
- Fixed file conflict /usr/lib/perl5/5.8.0/Memoize/README

* Wed Apr 30 2003 Christian H. Toldnes <christht at trustix dot dom> 5.8.0-5ct
- mv man3/threads.3 man3/perlthreads.3

* Wed Apr 30 2003 Christian H. Toldnes <christht at trustix dot dom> 5.8.0-4ct
- Merged perl and perl-base
- Cleanup

* Tue Mar 25 2003 Erlend Midttun <erlendbm at trustix dot com> 5.8.0-3em
- Now as i586

* Tue Mar 25 2003 Erlend Midttun <erlendbm at trustix dot com> 5.8.0-2em
- Added some more files.

* Mon Mar 24 2003 Erlend Midttun <erlendbm at trustix dot com> 5.8.0-1em
- Rebuilt on glibc 2.3.2.

* Mon Mar  3 2003 Goetz Bock <bock at trustix dot org> 5.8.0-0bg
- new upstream: 5.8.0
- rebuild with db4-4.1.25
- disabled DB_File (-Ui_db) as perl does not like db4-4.1.25
- splitted perl into 4 rpms: perl, perl-base, perl-devel, perl-doc

* Fri Sep 13 2002 Christian H. Toldnes <christht at trustix dot com> 5.6.1-13ct
- Patched to build with gcc-3.x (Patch0)

* Thu Jul 11 2002 Nico Erfurth <ne@perlgolf.de> 5.6.1-12ne
- Fixed LFS-check

* Fri Jun 28 2002 Nico Erfurth <ne@perlgolf.de> 5.6.1-11ne
- Using LargeFileSupport-Macro
- Added gdbm-devel to Build-Requires

* Mon May 30 2002 Nico Erfurth <masta at trustix dot org>
- Checks now for glibc version, if above 2.1 then 
  we use LARGEFILE else we refuse it
- Upgraded Digest::MD5 to version 2.20

* Mon May 27 2002 Nico Erfurth <masta at trustix dot org>
- Fixed the wrong location for man-pages
- changed the suffix from tr to ne

* Mon Feb 11 2002 Nico Erfurth <masta at trustix dot org>
- Fixed MD5-Compilation and installation

* Fri Jan 11 2002 Nico Erfurth <masta at trustix dot org>
- updated MD5 to 2.02

* Mon Oct 29 2001 Nico Erfurth <masta@kema.at>
- version 5.6.1
- updated version-format to MAJOR.MINOR.PATCHLEVEL
- added make test before make install

* Tue Jul  3 2001 Oystein Viggen <oysteivi at trustix dot com>
- define _noVersionedDependencies

* Mon Aug 14 2000 Oystein Viggen <oysteivi at trustix dot com>
- patch to use syslog instead of /bin/mail for reporting errors

* Tue Feb  8 2000 Tore Olsen <toreo at trustix dot com>
- moved /usr/man to /usr/share/man for FHS compliance

* Fri Jan 14 2000 Jeff Johnson <jbj@redhat.com>
- add provides for perl modules (from kestes@staff.mail.com).

* Mon Oct 04 1999 Cristian Gafton <gafton@redhat.com>
- fix the %install so that the MD5 module gets actually installed correctly

* Mon Aug 30 1999 Cristian Gafton <gafton@redhat.com>
- make sure the package builds even when we don't have perl installed on the
  system

* Fri Aug 06 1999 Cristian Gafton <gafton@redhat.com>
- merged with perl-MD5
- get rid of the annoying $RPM_BUILD_ROOT paths in the installed tree

* Mon Jul 26 1999 Cristian Gafton <gafton@redhat.com>
- do not link anymore against the system db library (and make each module
  link against it separately, so that we can have Berkeley db1 and db2 mixed
  up)

* Wed Jun 16 1999 Cristian Gafton <gafton@redhat.com>
- use wildcards for files in /usr/bin and /usr/man

* Tue Apr 06 1999 Cristian Gafton <gafton@redhat.com>
- version 5.00503
- make the default man3 install dir be release independent
- try to link against db1 to preserve compatibility with older databases;
  abandoned idea because perl is too broken to allow such an easy change
  (hardcoded names *everywhere* !!!)

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 3)

* Thu Jan 07 1999 Cristian Gafton <gafton@redhat.com>
- guilty of the inlined Makefile in the spec file
- adapted for the arm build

* Wed Sep 09 1998 Preston Brown <pbrown@redhat.com>
- added newer CGI.pm to the build
- changed the version naming scheme around to work with RPM

* Sun Jul 19 1998 Jeff Johnson <jbj@redhat.com>
- attempt to generate *.ph files reproducibly

* Mon Jun 15 1998 Jeff Johnson <jbj@redhat.com>
- update to 5.004_04-m4 (pre-5.005 maintenance release)

* Tue Jun 12 1998 Christopher McCrory <chrismcc@netus.com
- need stdarg.h from gcc shadow to fix "use Sys::Syslog" (problem #635)

* Fri May 08 1998 Cristian Gafton <gafton@redhat.com>
- added a patch to correct the .ph constructs unless defined (foo) to read
  unless(defined(foo))

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Tue Mar 10 1998 Cristian Gafton <gafton@redhat.com>
- fixed strftime problem

* Sun Mar 08 1998 Cristian Gafton <gafton@redhat.com>
- added a patch to fix a security race
- do not use setres[ug]id - those are not implemented on 2.0.3x kernels

* Mon Mar 02 1998 Cristian Gafton <gafton@redhat.com>
- upgraded to 5.004_04 - 5.004_01 had some nasty memory leaks.
- fixed the spec file to be version-independent

* Fri Dec 05 1997 Erik Troan <ewt@redhat.com>
- Config.pm wasn't right do to the builtrooting

* Mon Oct 20 1997 Erik Troan <ewt@redhat.com>
- fixed arch-specfic part of spec file

* Sun Oct 19 1997 Erik Troan <ewt@redhat.com>
- updated to perl 5.004_01
- users a build root

* Thu Jun 12 1997 Erik Troan <ewt@redhat.com>
- built against glibc

* Tue Apr 22 1997 Erik Troan <ewt@redhat.com>
- Incorporated security patch from Chip Salzenberg <salzench@nielsenmedia.com>

* Fri Feb 07 1997 Erik Troan <ewt@redhat.com>
- Use -Darchname=i386-linux 
- Require csh (for glob)
- Use RPM_ARCH during configuration and installation for arch independence
